# FILE: mmArchive.tcl
#

# Support libraries
package require Oc 1.0.1.2
package require Net
if {[Oc_Main HasTk]} {
    package require Tk
    package require Ow
}

Oc_Main SetAppName mmArchive
Oc_Main SetVersion 1.1.0.0
regexp \\\044Date:(.*)\\\044 {$Date: 1999/03/30 21:21:48 $} _ date
Oc_Main SetDate [string trim $date]
# regexp \\\044Author:(.*)\\\044 {$Author: dgp $} _ author
# Oc_Main SetAuthor [Oc_Person Lookup [string trim $author]]
Oc_Main SetAuthor [Oc_Person Lookup dgp]
Oc_Main SetHelpURL [Oc_Url FromFilename [file join [file dirname \
        [file dirname [file dirname [Oc_DirectPathname [info \
        script]]]]] doc userguide Data_Archive_mmArchive.html]]

Net_Protocol New protocol -name "OOMMF vectorField protocol 0.0"
$protocol AddMessage start datafile { fnlist } {
    set tmpfile [lindex $fnlist 0]
    set permfile [lindex $fnlist 1]
    if {[Oc_Main HasTk]} {
	global log
	$log Append "Writing $permfile ..."
    }
    # Ought to add lots of error checking here...
    file rename -force $tmpfile $permfile
    return [list start [list 0 0]]
}

$protocol AddMessage start HasGui {} {
    return [list start [list 0 0]]
}

Net_Server New server -protocol $protocol -alias [Oc_Main GetAppName] \
        -log Oc_Nop
$server Start 0

if {[Oc_Main HasTk]} {
    # Death
    proc Die { win } {
	if {![string match "." $win]} { return }  ;# Child destroy event
	global protocol
	if {[info exists protocol]} {
	    $protocol Delete; after 2000 exit
	} else {
	    exit
	}
    }
    bind . <Destroy> {+Die %W}

    # Menu bar
    set menubar .mb
    foreach {fmenu hmenu} [Ow_MakeMenubar . $menubar File Help] {}
    $fmenu add command -label "Exit" -command { Die . } -underline 1
    Ow_StdHelpMenu $hmenu

    if {$tk_version>=8.0 && \
	    [string match windows $tcl_platform(platform)]} {
	# Windows doesn't size Tcl 8.0 menubar cleanly
	Oc_DisableAutoSize .
	wm geometry . "[Ow_GuessMenuWidth $menubar]x1"
	update
	wm geometry . {}
	Oc_EnableAutoSize .
	update
    }

    # Log window
    Ow_Log New log -dateformat "" -title [Oc_Main GetInstanceName]
    Oc_EventHandler New _ $log Delete { after 2000 exit }

    # Title bar and icon
    wm title . [Oc_Main GetInstanceName]
    Ow_SetIcon .
}

vwait forever

