/* FILE: omfsh.cc                 -*-Mode: c++-*-
 *
 *	A Tcl shell extended by the OOMMF core (Oc) extension
 *
 * NOTICE: Plase see the file ../../LICENSE
 *
 * Last modified on: $Date: 1999/03/10 23:28:05 $
 * Last modified by: $Author: donahue $
 */

/* Header files for system libraries */
#include <string.h>

/* Header files for third-party extensions */
#include <tcl.h>
#include <tk.h>

/* Header files for the OOMMF extensions */
#include "oc.h"
#include "if.h"

/* End includes */     

/* 
 * The "application initialization" for OOMMF applications.
 */
int 
Tcl_AppInit(Tcl_Interp *interp)
{
    Oc_AutoBuf ab;
    if (Oc_Init(interp) != TCL_OK) {
        return TCL_ERROR;
    }
    Tcl_StaticPackage(interp, ab("Oc"), Oc_Init, NULL);
    // For now, always link in and initialize the If extension.
    // Eventually move to support selection of which extensions
    // to initialize on the basis of command line switches to
    // the shell.
    if (If_Init(interp) != TCL_OK) {
        return TCL_ERROR;
    }
    Tcl_StaticPackage(interp, ab("If"), If_Init, NULL);
    return TCL_OK;
}

int Oc_AppMain(int argc, char **argv)
{
  // Turn over control to the Oc library.
  Oc_Main(argc, argv, Tcl_AppInit);

  // Oc_Main and Tcl_Main does not return, so control never gets here.
  // Make picky compilers happy.
  return 0;
}

