# wintel.tcl
#
# Defines the Oc_Config name 'wintel' to indicate the Windows 95/NT operating
# system running on an Intel architecture.

Oc_Config New _ [string tolower [file rootname [file tail [info script]]]] {
    global tcl_platform tcl_library
    if {![regexp -nocase -- windows $tcl_platform(platform)]} {
        return 0
    }
    if {[info exists tcl_library] && \
	    [string first cygwin [string tolower $tcl_library]]>=0} {
	return 0
    }
    return [string match intel $tcl_platform(machine)]
}

