/* FILE: oc.h                    -*-Mode: c++-*-
 *
 *	The OOMMF Core extension public header file.
 *
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 1999/04/26 20:47:05 $
 * Last modified by: $Author: dgp $
 */

#ifndef _OC
#define _OC

#define OC_STRINGIFY(x) OC_STRINGIFY1(x)
#define OC_STRINGIFY1(x) #x

#define OC_MAKE_VERSION(x) OC_STRINGIFY(x##_MAJOR_VERSION) "." \
                           OC_STRINGIFY(x##_MINOR_VERSION) "." \
                           OC_STRINGIFY(x##_RELEASE_LEVEL) "." \
                           OC_STRINGIFY(x##_RELEASE_SERIAL)

/*
 * Get version macros from another file so they can be 
 * automatically generated
 */
#include "version.h"

#define OC_VERSION OC_MAKE_VERSION(OC)

/* Header containing macros and typedefs describing the platform */
#include "port.h"

/* Prototypes imported from other extensions and libraries */
#include "imports.h"

/* Prototypes of functions in this extension */
#include "byte.h"
#include "messages.h"

/* Declarations of classes in this extension */
#include "autobuf.h"

/* End includes */     /* Optional directive to pimake */

/* Functions to be passed to the Tcl/Tk libraries */
Tcl_PackageInitProc	Oc_Init;

/* Prototypes for the routines defined in oc.cc */
Tcl_Interp*	Oc_GlobalInterpreter();
int		Oc_InitScript(Tcl_Interp*, const char*, const char*);
int		Oc_AppMain(int,char**);
int		Oc_RegisterCommand(Tcl_Interp*,const char*,Tcl_CmdProc*);
void		Oc_SetDefaultTkFlag(int);
Tcl_CmdProc     Oc_AppendUsageInfo;
Tcl_CmdProc     Oc_GetUsageInfo;
void		Oc_Main(int,char**,Tcl_AppInitProc*);

#endif /* _OC */
